<!DOCTYPE html> <html lang="en">
<head>
    <link href="https://fonts.googleapis.com/css2?family=Oswald:wght@400;500;700&display=swap" rel="stylesheet">
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Button Click Example</title>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/socket.io/4.0.1/socket.io.min.js"></script>
        <script src="https://cdn.jsdelivr.net/npm/chart.js"></script>
            <script src="https://cdnjs.cloudflare.com/ajax/libs/gauge.js/1.3.7/gauge.min.js"></script>
                <script src="script.js"></script>


    <style>
        * {
  margin: 0;
  padding: 0;
  box-sizing: border-box;
}

button {
padding: 6px;
width: 10rem;
background-color: #2e2d79;
color: white;
border: 2px white solid;
border-radius: 10px;
font-family: 'Oswald', sans-serif;
cursor: pointer;
}

        body {
        font-family: 'Oswald', sans-serif;
        font-weight: 400; 
        }
        
        #black-div{
            background-color: rgba(0,0,0,0.8);
            width: 100vw;
            height: 100vh;
            position: absolute;
            z-index: 1000;
            pointer-events: none;
        }
        
       li {
           font-size: 24px;
           color: #2e2d79;
           }
        
        
        .container {
            margin-top: 50px;
            text-align: center;
        }
        
        h1{
            color: #2e2d79;
            }
    </style>
        <style>


	.buttons{
	display: flex;
	}
    
    .bodys{
  width: 100vw;
  height: 100vh;
  display: grid;
  grid-template-columns: repeat(4, 1fr);
  padding: 1rem;
  background-image: url('/static/back.jpg');
  background-size: cover;
  background-position: center;
  background-repeat: no-repeat;
  opacity: 1;
}




.child{
  background-color: gray;
  margin: 1rem;
  padding: 1rem;
  position: relative;
  border-radius: 17px;
      background-color: rgba(255, 255, 255, 0.85); 
    border: 4px solid white;  
  
  
}

        .container {
            margin-top: 50px;
            text-align: center;
            max-width: 100%; 
            overflow: hidden; 
        }

.bodys > :nth-child(1) {
  grid-column: span 3;
  text-align: center;
}

.bodys > :nth-child(2) {
  grid-column: span 1;
}

.bodys > :nth-child(3) {
  grid-row: span 2;
}

.bodys > :nth-child(3) {
  grid-row: span 2;
}

.bodys > :nth-child(5) {
  grid-column: span 2;
}

.bodys > :nth-child(6) {
  grid-column: span 2;
}

        .led {
            width: 100px;
            height: 100px;
            border-radius: 50%;
            background-image: radial-gradient(white, white, #2e2d79);
            box-shadow: 0 0 40px #2e2d79;
            margin-bottom: 20px;
            transition: background-color 0.3s, box-shadow 0.3s;
        }

        .led.off {
            background-image: none;
            background-color: gray;
            box-shadow: none;
        }


 
    </style>
</head>
<body>
    
    <div id="black-div"></div>
    
    
    <div class="bodys">


  <div class="child">
      <canvas id="myChart" style="position: absolute; top: 0; left: 0; width: 100% !important; height: 100%; z-index: 10;"></canvas>
  </div>
    <div class="child">
      <canvas width="200px" height="100px" id="gauge" ></canvas>
      
  </div>
  <div class="child">
      
              <h1>LIVE Sensor values <span id="demo"></span></h1>
              	
<div style="max-width: 100%; position: absolute; margin-left: 3rem">
    <ul class="container" id="dynamic-list">
        
    </ul>
</div>


  </div>
  <div class="child">
      
      <div style="margin-top: 3rem">
        <div style="text-align: center; margin-top: 1rem">
            <button style="opacity: 1 !important" id="connectButton">Connect</button>
            <button id="disconnectButton">Disconnect</button>
        </div>

  	<div style="text-align: center; margin-top: 1rem">
        <button id="myButtonA">Start Monitoring</button>
        <button id="stopButton">Stop Monitoring</button>
        <div style="margin-top: 1rem">
                <button style="text-align: center" id="saveFile">Save file</button>
        <button id="loadFile">Load file</button>
        </div>

        
        <input style="width: 10rem; border-color: blue; margin-top: 1rem" type="number" id="thresholdInput" placeholder="Enter threshold">
        <button id="setThresholdButton">Set Threshold</button>
        <p id="thres"></p>
        
        </div>

	</div>
  </div>
  <div class="child">
      <canvas id="myChartSaved" style="position: absolute; top: 0; left: 0; width: 100% !important; height: 100%; z-index: 10;"></canvas>
  </div>
  <div class="child">
      <canvas id="myChartDatabase" style="position: absolute; top: 0; left: 0; width: 100% !important; height: 100%; z-index: 10;"></canvas>
	  </div>
  <div class="child" style="display: flex; align-items: center; justify-content: center;">
      

  
  <div class="led" id="led"></div>
  </div>
 

</div>

</div>
    </div>

    <script>
        document.addEventListener("DOMContentLoaded", function() {
            var socket = io.connect(location.protocol + '//' + document.domain + ':' + location.port + '/test');

            let list = [];
            
                    const ledko = document.getElementById('led');

                    ledko.classList.add('off');
            
            const listElement = document.getElementById('connectButton');
            listElement.style.opacity = 1;
            
                document.getElementById('connectButton').addEventListener('click', function() {

                socket.emit('connect_uno');
                alert('NodeMcu was connected!')
            });
            
            document.getElementById('disconnectButton').addEventListener('click', function() {
                socket.emit('disconnect_uno');
                alert('NodeMcu was disconnected!')

            });


            socket.on('connect', function() {
                var message = document.createElement('p');
                console.log('insta')

                document.body.appendChild(message);
            });


            socket.on('serial_data', function(msg) {
                
                
                 let itemList = `LED Status: ${msg.ledStatus} | LED State: ${msg.ledState}`;
                list.push(itemList);
                
                            const led = document.getElementById('led');
                    
                    if (msg.ledState === 1) {
                    led.classList.remove('off');
                    const blackDiv = document.getElementById('black-div');
                    blackDiv.style.transition = "opacity 0.3s";
                    blackDiv.style.opacity = 0;
                    
                    
                } else {
                    const blackDiv = document.getElementById('black-div');
                    blackDiv.style.transition = "opacity 0.3s";
                    blackDiv.style.opacity = 1;
                    led.classList.add('off');
                }

    
  
                
                if (list.length > 10) {
                    list.shift();
                }
                
                const listElement = document.getElementById('dynamic-list');

                
                listElement.innerHTML = '';

                
                list.forEach(item => {
                    const li = document.createElement('li');
                    li.textContent = item;
                    listElement.appendChild(li);
                });
                
                
                const newValue = parseFloat(msg.ledStatus);
                dataArray.push(newValue);
                
                const newLabel = `${msg.datetime}`;
                config.data.labels.push(newLabel);
                gauge.set(newValue); 
                


                
                myChart.update();
            });
            
            

            document.getElementById('myButtonA').addEventListener('click', function() {
                document.getElementById('demo').innerHTML = " - ON";
                socket.emit('connect_buttonA');
                socket.emit('start_recieving'); 
            });


            document.getElementById('stopButton').addEventListener('click', function() {
                document.getElementById('demo').innerHTML = " - OFF";
                socket.emit('stop_sending');
            });

            document.getElementById('saveFile').addEventListener('click', function() {
                socket.emit('save_file');
            });

            document.getElementById('loadFile').addEventListener('click', function() {
                socket.emit('load_file');
            });

	    socket.on('load_data_js', function(json){
		    console.log(json.jsonObject)
		    let jsonArray = json.jsonObject;
		for(var i in jsonArray){

                const newValue = parseFloat(jsonArray[i].led_status);
                dataArraySaved.push(newValue);
                
                const newLabel = `${jsonArray[i].datetime}`;
                configSaved.data.labels.push(newLabel);
                myChartSaved.update();
		}
	    })
        
        


            document.getElementById('setThresholdButton').addEventListener('click', function() {
                var threshold = document.getElementById('thresholdInput').value;
                document.getElementById('thres').innerHTML = "Threshold set to " + threshold;
                socket.emit('set_threshold', { threshold: threshold });
                opts.staticZones[0].max = threshold;
                opts.staticZones[1].min = threshold;
        gauge.update();
            });

            socket.on('my_response', function(msg) {
            });


            socket.on('disconnect', function() {
                var message = document.createElement('p');
                message.innerText = 'Client disconnected!';
                document.body.appendChild(message);
            });
        });
        
        document.addEventListener("DOMContentLoaded", function() {
   
    
});

        
        

const dataArray = [];
const dataArraySaved = [];
const dataArrayDatabase = [];


const ctx = document.getElementById('myChart').getContext('2d');
const ctxSaved = document.getElementById('myChartSaved').getContext('2d');
const ctxDatabase = document.getElementById('myChartDatabase').getContext('2d');

const config = {
    type: 'line', 
    data: {
        labels: [], 
        datasets: [{
            label: 'LIVE Data from sensor',
            backgroundColor: '#2e2d79', 
            borderColor: '#2e2d79', 
            data: dataArray, 
            fill: false,
            pointBackgroundColor: '#2e2d79', 
            pointBorderColor: '#2e2d79', 
        }]
    },
    options: {
        responsive: true,
        maintainAspectRatio: false,
	            plugins: {
            legend: {
                labels: {
                    color: '#2e2d79', 
                }
            }
        },
        scales: {
            x: {
                display: true,
                title: {
                    display: true,
                    text: 'TimeStamp',
                    color: '#2e2d79'
                },
                ticks: {
                    color: '#2e2d79',
                    font: {
                        size: 10
                    }
                },
                grid: {
                    color: '#2e2d79',
                }
            },
            y: {
                display: true,
                title: {
                    display: true,
                    text: 'LED Status',
                    color: '#2e2d79'
                },
                ticks: {
                    color: '#2e2d79',
                    font: {
                        size: 10
                    }
                },
                grid: {
                    color: '#2e2d79',
                },
                suggestedMin: 0,
                suggestedMax: 6
            }
        }
    }
};


const configSaved = {
    type: 'line',
    data: {
        labels: [], 
        datasets: [{
            label: 'SAVED Data from sensor',
            backgroundColor: '#2e2d79',
            borderColor: '#2e2d79',
            data: dataArraySaved, 
            fill: false,
            pointBackgroundColor: '#2e2d79', 
            pointBorderColor: '#2e2d79', 
        }]
    },
    options: {
        responsive: true,
        maintainAspectRatio: false,
	            plugins: {
            legend: {
                labels: {
                    color: '#2e2d79', 
                }
            }
        },
        scales: {
            x: {
                display: true,
                title: {
                    display: true,
                    text: 'TimeStamp',
                    color: '#2e2d79'
                },
                ticks: {
                    color: '#2e2d79',
                    font: {
                        size: 10
                    }
                },
                grid: {
                    color: '#2e2d79',
                }
            },
            y: {
                display: true,
                title: {
                    display: true,
                    text: 'LED Status',
                    color: '#2e2d79'
                },
                ticks: {
                    color: '#2e2d79',
                    font: {
                        size: 10
                    }
                },
                grid: {
                    color: '#2e2d79',
                },
                suggestedMin: 0,
                suggestedMax: 6
            }
        }
    }
};


const configDatabase = {
    type: 'line', 
    data: {
        labels: [], 
        datasets: [{
            label: 'Database Data from sensor (Yet to be implmented)',
            backgroundColor: '#2e2d79', 
            borderColor: '#2e2d79', 
            data: dataArrayDatabase, 
            fill: false,
            pointBackgroundColor: '#2e2d79', 
            pointBorderColor: '#2e2d79', 
        }]
    },
    options: {
        responsive: true,
        maintainAspectRatio: false,
	            plugins: {
            legend: {
                labels: {
                    color: '#2e2d79', 
                }
            }
        },
        scales: {
            x: {
                display: true,
                title: {
                    display: true,
                    text: 'TimeStamp',
                    color: '#2e2d79'
                },
                ticks: {
                    color: '#2e2d79',
                    font: {
                        size: 10
                    }
                },
                grid: {
                    color: '#2e2d79',
                }
            },
            y: {
                display: true,
                title: {
                    display: true,
                    text: 'LED Status',
                    color: '#2e2d79'
                },
                ticks: {
                    color: '#2e2d79',
                    font: {
                        size: 10
                    }
                },
                grid: {
                    color: '#2e2d79',
                },
                suggestedMin: 0,
                suggestedMax: 6
            }
        }
    }
};


const myChart = new Chart(ctx, config);
const myChartSaved = new Chart(ctxSaved, configSaved);
const myChartDatabase = new Chart(ctxDatabase, configDatabase);

var globalthres = 500;
 var opts = {
            angle: 0.0, 
            lineWidth: 0.2, 
            radiusScale: 1, 
            pointer: {
                length: 0.6, 
                strokeWidth: 0.035,
                color: '#000000' 
            },
            limitMax: false,   
            limitMin: false,  
            highDpiSupport: true,     
            staticZones: [
                {strokeStyle: "#2e2d79", min: 0, max: 500}, 
                {strokeStyle: "grey", min: 500, max: 1024}, 
            ],
        };

        var target = document.getElementById('gauge'); 
        var gauge = new Gauge(target).setOptions(opts); 

        gauge.maxValue = 1024;
        gauge.setMinValue(0);  
        gauge.set(65); 
        opts.staticZones[0].max = 500;
        opts.staticZones[1].min = 500;





        
    </script>
</body>
</html>
